---
title: Worker.onmessage
slug: Web/API/Worker/onmessage
tags:
  - API
  - EventHandler
  - Property
  - Reference
  - Référence(2)
  - Web Workers
  - Worker
  - onmessage
---
<p>{{APIRef("Web Workers API")}}</p>

<p>The <strong><code>onmessage</code></strong> property of the {{domxref("Worker")}} interface represents an {{domxref("EventHandler")}}, that is a function to be called when the {{event("message")}} event occurs. These events are of type {{domxref("MessageEvent")}} and will be called when the worker's parent receives a message (i.e. from the {{domxref("DedicatedWorkerGlobalScope.postMessage")}} method).</p>

<div class="note">
<p><strong>Note</strong>: The message payload is available in the {{event("message")}} event's <code>data</code> property.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">myWorker.onmessage = function(e) { ... }</pre>

<h2 id="Example">Example</h2>

<p>The following code snippet shows creation of a {{domxref("Worker")}} object using the {{domxref("Worker.Worker", "Worker()")}} constructor. Messages are passed to the worker when the value inside the form input <code>first</code> changes. An onmessage handler is also present, to deal with messages that are passed back from the worker.</p>

<pre class="brush: js">var myWorker = new Worker('worker.js');

first.onchange = function() {
  myWorker.postMessage([first.value,second.value]);
  console.log('Message posted to worker');
}

myWorker.onmessage = function(e) {
  result.textContent = e.data;
  console.log('Message received from worker');
}
</pre>

<p>In the <code>worker.js</code> script, an <code>onmessage</code> handler is used to the handle messages from the main script:</p>

<pre class="brush: js">onmessage = function(e) {
  console.log('Message received from main script');
  var workerResult = 'Result: ' + (e.data[0] * e.data[1]);
  console.log('Posting message back to main script');
  postMessage(workerResult);
}</pre>

<p>Notice how in the main script, <code>onmessage</code> has to be called on <code>myWorker</code>, whereas inside the worker script you just need <code>onmessage</code> because the worker is effectively the global scope ({{domxref("DedicatedWorkerGlobalScope")}}).</p>

<p>For a full example, see our<a class="external external-icon" href="https://github.com/mdn/simple-web-worker">Basic dedicated worker example</a> (<a class="external external-icon" href="https://mdn.github.io/simple-web-worker/">run dedicated worker</a>).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#handler-worker-onmessage", "Worker.onmessage")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Worker.onmessage")}}</p>

<h2 id="See_also">See also</h2>

<p>The {{domxref("Worker")}} interface it belongs to.</p>
